<#assign import_block>
import CodeListService from '@service/app/codelist-service';
<#if ctrl.getPSDETreeNodes()??>
<#list ctrl.getPSDETreeNodes() as node>
<#if node.getTreeNodeType() == 'DE' && node.getPSAppDataEntity()??>
<#if appde?? && appde.getId() != node.getPSAppDataEntity().getId()>
<#if !P.exists("importService", node.getPSAppDataEntity().getId(), "")>
import ${srfclassname('${node.getPSAppDataEntity().codeName}')}Service from '@service/${srffilepath2(node.getPSAppDataEntity().codeName)}/${srffilepath2(node.getPSAppDataEntity().codeName)}-service';
</#if>
</#if>
</#if>
</#list>
</#if>
</#assign>
<#ibizinclude>
../@MACRO/SERVICE/SERVICE_HEADER.ts.ftl
</#ibizinclude>

    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof ${srfclassname('${ctrl.codeName}')}Service
     */
    public codeListService:CodeListService = new CodeListService({ $store: this.getStore() });

<#if ctrl.getPSDETreeNodes()??>
<#list ctrl.getPSDETreeNodes() as node>
<#if node.getTreeNodeType() == 'DE' && node.getPSAppDataEntity()??>
<#if appde?? && appde.getId() != node.getPSAppDataEntity().getId()>
<#if !P.exists("importService2", node.getPSAppDataEntity().getId(), "")>

    /**
     * ${node.getPSAppDataEntity().getLogicName()}服务对象
     *
     * @type {${srfclassname('${node.getPSAppDataEntity().codeName}')}Service}
     * @memberof ${srfclassname('${ctrl.codeName}')}Service
     */
    public ${node.getPSAppDataEntity().codeName?lower_case}Service: ${srfclassname('${node.getPSAppDataEntity().codeName}')}Service = new ${srfclassname('${node.getPSAppDataEntity().codeName}')}Service({ $store: this.getStore() });
</#if>
</#if>
</#if>
</#list>
</#if>

    /**
     * 节点分隔符号
     *
     * @private
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Service
     */
    private TREENODE_SEPARATOR: string = ';';
<#if ctrl.getPSDETreeNodes()??>
<#list ctrl.getPSDETreeNodes() as node>

    /**
     * ${node.getName()}节点分隔符号
     *
     * @private
     * @type {string}
     * @memberof ${srfclassname('${ctrl.codeName}')}Service
     */
	private TREENODE_${node.getNodeType()?upper_case}: string = '${node.getNodeType()?j_string}';
</#list>
</#if>

    /**
     * 获取节点数据
     *
     * @param {string} action
     * @param {*} [data={}]
     * @param {boolean} [isloading]
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Service
     */
    @Errorlog
    public async getNodes(context:any = {},data: any = {}, isloading?: boolean): Promise<any> {
        let { srfparentkey, srfcat, srfnodeid, srfnodefilter, query }: { srfparentkey: string, srfcat: string, srfnodeid: string, srfnodefilter: string, query:string } = data;
        srfnodefilter = query ? query : srfnodefilter;
        let list: any[] = [];
        let filter: any = {};


    <#--  BEGIN：逻辑代码  -->
        if (!srfnodeid || Object.is(srfnodeid, '#')) {
            <#if ctrl.isRootVisible()>
            await this.fill${srfclassname(ctrl.getRootPSDETreeNode().getNodeType()?lower_case)}Nodes(filter, list);
            return Promise.resolve({ status: 200, data: list });
            <#else>
            srfnodeid = this.TREENODE_${ctrl.getRootPSDETreeNode().getNodeType()?upper_case};
            </#if>
        }

        let strTreeNodeId: string = srfnodeid;
        let strRealNodeId: string = '';
        let bRootSelect: boolean = false;
        let strNodeType: string | null = null;
        let strRootSelectNode: string = '';

        if (Object.is(strTreeNodeId, this.TREENODE_${ctrl.getRootPSDETreeNode().getNodeType()?upper_case})) {
            strNodeType = this.TREENODE_${ctrl.getRootPSDETreeNode().getNodeType()?upper_case};
            if (srfparentkey) {
                strRealNodeId = srfparentkey;
            }
        } else {
            let nPos = strTreeNodeId.indexOf(this.TREENODE_SEPARATOR);
            if (nPos === -1) {
                return Promise.reject({ status: 500, data: { title: '失败', message: `树节点${r'${strTreeNodeId}'}标识无效` } });
            }
            strNodeType = strTreeNodeId.substring(0, nPos);
			strRealNodeId = strTreeNodeId.substring(nPos + 1);
        }

        Object.assign(filter,
            {
                srfparentkey: srfparentkey,
                srfcat: srfcat,
                srfnodefilter: srfnodefilter,
                strRealNodeId: strRealNodeId,
                srfnodeid: srfnodeid,
                strNodeType: strNodeType
            }
        );

        // 分解节点标识
        let nodeid: string[] = strRealNodeId.split(this.TREENODE_SEPARATOR);
        for (let i = 0; i < nodeid.length; i++) {
            switch (i) {
                case 0:
                    Object.assign(filter, { nodeid: nodeid[0] });
                    break;
                case 1:
                    Object.assign(filter, { nodeid2: nodeid[1] });
                    break;
                case 2:
                    Object.assign(filter, { nodeid3: nodeid[2] });
                    break;
                case 3:
                    Object.assign(filter, { nodeid4: nodeid[3] });
                    break;
                default:
                    break;
            }
        }

        <#if ctrl.getPSDETreeNodes()??>
        <#list ctrl.getPSDETreeNodes() as node>
        if (Object.is(strNodeType, this.TREENODE_${node.getNodeType()?upper_case})) {
            await this.fill${srfclassname(node.getNodeType()?lower_case)}NodeChilds(context,filter, list);
            return Promise.resolve({ status: 200, data: list });
        }
        </#list>
        </#if>
    <#--  END：逻辑代码  -->
        return Promise.resolve({ status: 500, data: { title: '失败', message: `树节点${r'${strTreeNodeId}'}标识无效` } });
    }

<#--  BEGIN：填充代码  -->
<#if ctrl.getPSDETreeNodes()??>
<#list ctrl.getPSDETreeNodes() as node>
<#assign filtername="">
<#assign entityname="">
    /**
     * 填充 树视图节点[${node.getName()}]
     *
     * @private
     * @param {any{}} context     
     * @param {*} filter
     * @param {any[]} list
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Service
     */
    @Errorlog
    private fill${srfclassname(node.getNodeType()?lower_case)}Nodes(context:any={},filter: any, list: any[]): Promise<any> {
        return new Promise((resolve:any,reject:any) =>{
    <#if node.getTreeNodeType() == 'STATIC'>
            let treeNode: any = {};
            Object.assign(treeNode, { text: '${appde.getCodeName()?lower_case}.${ctrl.getCodeName()?lower_case}_${ctrl.getControlType()?lower_case}.nodes.${node.getNodeType()?lower_case}' });
            Object.assign(treeNode, { isUseLangRes: true });
    <#if node.isEnableQuickSearch()>
            if (treeNode.srfnodefilter) {
                if (treeNode.text().toUpperCase().indexOf(filter.srfnodefilter.toUpperCase()) === -1) {
                    return Promise.reject();
                }
            }

    </#if>
            Object.assign(treeNode, { srfmajortext: treeNode.text });
            let strNodeId: string = '${node.getNodeType()?j_string}';

          <#if node.getNodeValue()?? && node.getNodeValue()?length gt 0>
            Object.assign(treeNode, { srfkey: '${node.getNodeValue()?j_string}' });
            strNodeId += this.TREENODE_SEPARATOR;
            strNodeId += '${node.getNodeValue()?j_string}';

            <#if node.isAppendPNodeId()>
            strNodeId += this.TREENODE_SEPARATOR;
            strNodeId += filter.realnodeid;

            </#if>
          <#else>
            // 没有指定节点值，直接使用父节点值
            Object.assign(treeNode, { srfkey: filter.realnodeid });
            strNodeId += this.TREENODE_SEPARATOR;
            strNodeId += filter.realnodeid;

          </#if>
            Object.assign(treeNode, { id: strNodeId });

            <#if node.getPSSysImage()??>
            <#if node.getPSSysImage().getCssClass()?? && node.getPSSysImage().getCssClass()?length gt 0>
            Object.assign(treeNode, { iconcls: '${node.getPSSysImage().getCssClass()}' });

            <#else>
            Object.assign(treeNode, { icon: '${node.getPSSysImage().getImagePath()}' });

            </#if>
            </#if>
            <#if node.isEnableCheck()>
            Object.assign(treeNode, { enablecheck: true });

            </#if>
            <#if node.isDisableSelect()>
            Object.assign(treeNode, { disabled: true });

            </#if>
            <#if node.isExpanded()>
            Object.assign(treeNode, { expanded: true });
            <#else>
            Object.assign(treeNode, { expanded: filter.isAutoexpand });
            </#if>
            <#if node.hasPSDETreeNodeRSs()>
            Object.assign(treeNode, { leaf: false });
            <#else>
            Object.assign(treeNode, { leaf: true });
            </#if>
            <#if node.isSelected()>
            Object.assign(treeNode, { selected: true });
            </#if>
            <#if node.getNavFilter()??>
            Object.assign(treeNode, { navfilter: "${node.getNavFilter()}" });
            </#if>
            list.push(treeNode);
            resolve(list);
        });
</#if>
<#if node.getTreeNodeType() == 'CODELIST' && node.getPSCodeList()??>
        <#if node.getPSCodeList().getCodeListType()?? && node.getPSCodeList().getCodeListType() == 'STATIC'>
            let codeListIems:Array<any> = [];
            if (this.getStore()) {
                codeListIems = (this.getStore() as any).getters.getCodeListItems('${node.getPSCodeList().codeName}');
            }
        <#elseif node.getPSCodeList().getCodeListType()?? && node.getPSCodeList().getCodeListType() == 'DYNAMIC'>
            this.codeListService.getItems('${node.getPSCodeList().codeName}',context).then((codeListIems:any) =>{
                return codeListIems;
            }).then((codeListIems:any)=>{
        </#if>
            if(codeListIems && codeListIems.length >0){
                let bFirst:boolean = true;
                codeListIems.forEach((item:any) => {
                    let treeNode: any = {};
                    <#if node.getPSCodeList().getCodeListType() == 'STATIC'>
                    Object.assign(treeNode, { text: 'codelist.${node.getPSCodeList().codeName}.'+item.value });
                    Object.assign(treeNode, { isUseLangRes: true });
                    <#else>
                    Object.assign(treeNode, { text: item.text });
                    </#if>
                    <#if node.isEnableQuickSearch()>
                    if(filter.srfnodefilter){
                        if(treeNode.getText().toUpperCase().indexOf(filter.getSrfnodefilter().toUpperCase())==-1)
                            continue;
                    }
                    </#if>
                    Object.assign(treeNode, { srfmajortext: treeNode.text });
                    let strNodeId: string = "${srfjavastring(node.getNodeType())}";
                    Object.assign(treeNode, { srfkey: item.value });
                    strNodeId += this.TREENODE_SEPARATOR;
                    strNodeId += item.value;
                    <#if node.isAppendPNodeId()>
                    strNodeId += TREENODE_SEPARATOR;
                    strNodeId += filter.getRealnodeid();
                    </#if>
                    Object.assign(treeNode, { id: strNodeId });
                    <#if node.getPSSysImage()??>
                    <#if node.getPSSysImage().getCssClass()?? && node.getPSSysImage().getCssClass()?length gt 0>
                    Object.assign(treeNode, { iconcls: '${node.getPSSysImage().getCssClass()}' });
                    <#else>
                    Object.assign(treeNode, { icon: '${node.getPSSysImage().getImagePath()}' });
                    </#if>
                    </#if>
                    <#if node.isEnableCheck()>
                    Object.assign(treeNode, { enablecheck: true });
                    </#if>
                    <#if node.isDisableSelect()>
                    Object.assign(treeNode, { disabled: true });
                    </#if>
                    <#if node.isExpanded()>
                    <#if node.isExpandFirstOnly()>
                    Object.assign(treeNode, { expanded: bFirst });
                    <#else>
                    Object.assign(treeNode, { expanded: true });
                    </#if>
                    <#else>
                    Object.assign(treeNode, { expanded: filter.isautoexpand });
                    </#if>
                    <#if node.hasPSDETreeNodeRSs()>
                    Object.assign(treeNode, { leaf: false });
                    <#else>
                    Object.assign(treeNode, { leaf: true });
                    </#if>
                    <#if node.isSelected()>
                    Object.assign(treeNode, { selected: true });
                    </#if>
                    <#if node.getNavFilter()??>
                    Object.assign(treeNode, { navfilter: "${node.getNavFilter()}" });
                    </#if>
                    list.push(treeNode);
                    bFirst = false;
                    resolve(list);
                })
             }else{
                resolve(list);
             }
            <#if node.getPSCodeList().getCodeListType()?? && node.getPSCodeList().getCodeListType() == 'DYNAMIC'>
            });
            </#if>
        });
</#if>
<#if node.getTreeNodeType() == 'DE' && node.getPSDataEntity()??>
    <#assign filtername>${node.getPSDataEntity().codeName}SearchFilter</#assign>
    <#assign entityname>${node.getPSDataEntity().codeName}</#assign>
            let searchFilter: any = {};

    <#list ctrl.getPSDETreeNodeRSs() as noders>
    <#if noders.getChildPSDETreeNode().id == node.id>
    <#if noders.getParentFilter()?? && noders.getParentFilter()?length gt 0>
    <#assign pickupfield=noders.getParentFilter()>

            if (Object.is(filter.strNodeType, this.TREENODE_${noders.getParentPSDETreeNode().getNodeType()?upper_case})) {
                Object.assign(searchFilter, { n_${pickupfield?lower_case}_eq: filter.nodeid<#if noders.getParentValueLevel() gt 1>${noders.getParentValueLevel()?c}</#if> });
            }

    <#elseif noders.getParentPSDER1N()??>
    <#assign pickupfield=noders.getParentPSDER1N().getPSPickupDEField()>
            if (Object.is(filter.strNodeType, this.TREENODE_${noders.getParentPSDETreeNode().getNodeType()?upper_case})) {
                Object.assign(searchFilter, { n_${pickupfield.getName()?lower_case}_eq: filter.nodeid<#if noders.getParentValueLevel() gt 1>${noders.getParentValueLevel()?c}</#if> });
            }

    </#if>
    </#if>
    </#list>
            Object.assign(searchFilter, { total: false });
            <#-- nodeid 是前台专用的 -->
            <#--  Object.assign(searchFilter, {nodeid: filter.nodeid});  -->
    <#if node.isEnableQuickSearch()>
            Object.assign(searchFilter, { query: filter.srfnodefilter });
    <#else>
            // 节点不支持搜索
    </#if>
            let bFirst: boolean = true;
            let records: any[] = [];
            try {
                this.search${srfclassname(node.getNodeType()?lower_case)}(context, searchFilter, filter).then((records:any) =>{
                    if(records && records.length >0){
                        records.forEach((entity: any) => {
                        let treeNode: any = {}
                        let strId: string = entity.${node.getPSAppDataEntity().getKeyPSAppDEField().codeName?lower_case};
                        <#if node.getTextPSDEField()??>
                        let strText: string = entity.${node.getTextPSDEField().codeName?lower_case};
                        <#else>
                        let strText: string = entity.${node.getPSAppDataEntity().getMajorPSAppDEField().codeName?lower_case};
                        </#if>
                        Object.assign(treeNode, { srfkey: strId });
<#--                        <#if node.getTextFormat()?? && node.getTextFormat()?length gt 0>-->
<#--                        Object.assign(treeNode, { text: '${node.getText()?j_string}', srfmajortext: treeNode.text });-->
<#--                        <#else>-->
                        Object.assign(treeNode, { text: strText, srfmajortext: strText });
<#--                        </#if>-->
                        let strNodeId: string = '${node.getNodeType()?j_string}';
                        strNodeId += this.TREENODE_SEPARATOR;
                        strNodeId += strId;
                        <#if node.isAppendPNodeId()>
                        strNodeId += this.TREENODE_SEPARATOR;
                        strNodeId += filter.realnodeid;
                        </#if>
                        Object.assign(treeNode, { id: strNodeId });
                        <#if node.getPSSysImage()??>
                        <#if node.getPSSysImage().getCssClass()?? && node.getPSSysImage().getCssClass()?length gt 0>
                        Object.assign(treeNode, { iconcls: '${node.getPSSysImage().getCssClass()}' });
                        <#else>
                        Object.assign(treeNode, { icon: '${node.getPSSysImage().getImagePath()}' });
                        </#if>
                        </#if>
                        <#if node.isEnableCheck()>
                        Object.assign(treeNode, { enablecheck: true });
                        </#if>
                        <#if node.isDisableSelect()>
                        Object.assign(treeNode, { disabled: true });
                        </#if>
                        <#if node.isExpanded()>
                        <#if node.isExpandFirstOnly()>
                        Object.assign(treeNode, { expanded: bFirst });
                        <#else>
                        Object.assign(treeNode, { expanded: true });
                        </#if>
                        <#else>
                        Object.assign(treeNode, { expanded: filter.isautoexpand });
                        </#if>
                        <#if node.hasPSDETreeNodeRSs()>
                        Object.assign(treeNode, { leaf: false });
                        <#else>
                        Object.assign(treeNode, { leaf: true });
                        </#if>
                        <#if node.getLeafFlagPSDEField()??>
                        let objLeafFlag = entity.${node.getLeafFlagPSDEField().codeName?lower_case};
                        if (objLeafFlag != null ) {
                            let strLeafFlag: string = objLeafFlag.toString().toLowerCase();
                            if (Object.is(strLeafFlag, '1') || Object.is(strLeafFlag, 'true')){
                                Object.assign(treeNode, { leaf: true });
                            }
                        }
                        </#if>
                        <#if node.getPSDETreeNodeDataItems()??>
                        <#list node.getPSDETreeNodeDataItems() as dataitem>
                        <#if dataitem.getPSDEField()??>
                        Object.assign(treeNode, { ${dataitem.name?lower_case}: entity.${dataitem.getPSDEField().codeName?lower_case} });
                        </#if>
                        </#list>
                        </#if>
                        <#if node.isSelected()>
                        Object.assign(treeNode, { selected: true });
                        </#if>
                        <#if node.getNavFilter()??>
                        Object.assign(treeNode, { navfilter: "${node.getNavFilter()}" });
                        </#if>
                        list.push(treeNode);
                        resolve(list);
                        bFirst = false;
                    });
                    }else{
                        resolve(list);
                    }
                });
            } catch (error) {
                console.error(error);
            }
        });

</#if>
	}
<#if (filtername?length gt 0) && (entityname?length gt 0)>

    /**
     * 获取查询集合
     *
     * @private
     * @param {any{}} context     
     * @param {*} searchFilter
     * @param {*} filter
     * @returns {any[]}
     * @memberof TestEnetityDatasService
     */
    @Errorlog
    private search${srfclassname(node.getNodeType()?lower_case)}(context:any={}, searchFilter: any, filter: any): Promise<any> {
        return new Promise((resolve:any,reject:any) =>{
            if(!searchFilter.page){
                Object.assign(searchFilter,{page:0});
            }
            if(!searchFilter.size){
                Object.assign(searchFilter,{size:1000});
            }
            <#if node.getSortField?? && node.getSortField()?? && node.getSortDir?? && node.getSortDir()??>
            Object.assign(searchFilter,{sort: '${node.getSortField()?lower_case},${node.getSortDir()?lower_case}'})
            </#if>
            <#if appde?? && appde.getId() != node.getPSAppDataEntity().getId()>
            const _appEntityService: any = this.${node.getPSAppDataEntity().codeName?lower_case}Service;
            <#else>
            const _appEntityService: any = this.appEntityService;
            </#if>
            let list: any[] = [];
            if (_appEntityService['${node.getPSAppDEDataSet().getCodeName()}'] && _appEntityService['${node.getPSAppDEDataSet().getCodeName()}'] instanceof Function) {
                const response: Promise<any> = _appEntityService['${node.getPSAppDEDataSet().getCodeName()}'](context, searchFilter, false);
                response.then((response: any) => {
                    if (!response.status || response.status !== 200) {
                        reject("数据集异常!");
                    }
                    const data: any = response.data;
                    if (Object.keys(data).length > 0) {
                        list = JSON.parse(JSON.stringify(data));
                        resolve(list);
                    } else {
                        resolve([]);
                    }
                }).catch((response: any) => {
                    reject("数据集异常!");
                });
            }
        })
    }
</#if>

    /**
     * 填充 树视图节点[${node.getName()}]子节点
     *
     * @private
     * @param {any{}} context         
     * @param {*} filter
     * @param {any[]} list
     * @returns {Promise<any>}
     * @memberof ${srfclassname('${ctrl.codeName}')}Service
     */
    @Errorlog
    private async fill${srfclassname(node.getNodeType()?lower_case)}NodeChilds(context:any={}, filter: any, list: any[]): Promise<any> {
	<#if ctrl.getPSDETreeNodeRSs()??>
		if (!filter.srfnodefilter) {
		<#list ctrl.getPSDETreeNodeRSs() as noders>
		<#if noders.getParentPSDETreeNode().id == node.id>
		<#if noders.getSearchMode() == 1 || noders.getSearchMode() == 3>
			// 填充${noders.getChildPSDETreeNode().getName()}
			await this.fill${srfclassname(noders.getChildPSDETreeNode().getNodeType()?lower_case)}Nodes(context, filter, list);
		</#if>
		</#if>
		</#list>
		} else {
		<#list ctrl.getPSDETreeNodeRSs() as noders>
		<#if noders.getParentPSDETreeNode().id == node.id>
		<#if noders.getSearchMode() == 2 || noders.getSearchMode() == 3>
			// 填充${noders.getChildPSDETreeNode().getName()}
			await this.fill${srfclassname(noders.getChildPSDETreeNode().getNodeType()?lower_case)}Nodes(context, filter, list);
		</#if>
		</#if>
		</#list>
		}
	</#if>
	}

</#list>
</#if>
<#ibizinclude>
../@MACRO/SERVICE/SERVICE_BOTTOM.ts.ftl
</#ibizinclude>