<#ibizinclude>
../@MACRO/CONTROL/LANGBASE.vue.ftl
</#ibizinclude>
<template v-if="getColumnState('${item.getName()?lower_case}')">
<#if item.getColumnType() == 'GROUPGRIDCOLUMN' && item.getPSDEGridColumns()??>
<#--  BEGIN：分组列  -->
    <el-table-column show-overflow-tooltip :align="'${item.getAlign()?lower_case}'" :label="<#if langbase??>$t('${langbase}.columns.${item.getName()?lower_case}')<#else>'${item.getCaption()}'</#if>">
    <#list item.getPSDEGridColumns() as column>
        ${P.getPartCode(column,'COLUMN').code}
    </#list>
    </el-table-column>
<#--  END：分组列  -->
<#elseif item.getColumnType() == 'UAGRIDCOLUMN'>
<#--  BEGIN：操作列  -->
    <el-table-column :column-key="'${item.getName()?lower_case}'" :label="<#if langbase??>$t('${langbase}.columns.${item.getName()?lower_case}')<#else>'${item.getCaption()}'</#if>"<#if item.getWidthUnit()!='STAR'> :width="${item.width?c}"</#if> :align="'${item.getAlign()?lower_case}'">
        <template slot-scope="scope">
            <span>
                <#if item.getPSDEUIActionGroup().getPSDEUIActions()??>
                <#list item.getPSDEUIActionGroup().getPSDEUIActions() as uiaction>
                <#if uiaction_index gt 0><divider type='vertical'></divider></#if>
                <a @click="uiAction(scope.row, '${uiaction.getUIActionTag()}', $event)">{{<#if langbase??>$t('${langbase}.uiactions.${uiaction.getUIActionTag()?lower_case}')<#else>'${uiaction.getCaption()}'</#if>}}</a>
                </#list>
                </#if>
            </span>
        </template>
    </el-table-column>
<#--  END：操作列  -->
<#elseif item.getColumnType() == 'DEFGRIDCOLUMN'>
<#--  BEGIN：数据列  -->
    <el-table-column show-overflow-tooltip :prop="'${item.getName()?lower_case}'" :label="<#if langbase??>$t('${langbase}.columns.${item.getName()?lower_case}')<#else>'${item.getCaption()}'</#if>"<#if item.getWidthUnit()!='STAR'> :width="${item.width?c}"</#if> :align="'${item.getAlign()?lower_case}'"<#if (!ctrl.isNoSort()) && item.isEnableSort()> :sortable="'custom'"</#if>>
        <template v-slot="{row,column}">
        <#if (item.render??) || (item.getCodeList()?? && item.getCLConvertMode() == 'FRONT') || (ctrl.isEnableRowEdit() && item.isEnableRowEdit())>
        <#--  BEGIN：列绘制、前端绘制代码表、行编辑  -->
            <#if (ctrl.isEnableRowEdit() && item.isEnableRowEdit())>
            <#--  BEGIN：行编辑  -->
              <#if (item.render??)>
              <#--  BEGIN：列绘制  -->
                    <span>${item.render.code}</span>
              <#--  END：列绘制  -->
              <#else>
            <template v-if="actualIsOpenEdit">
                <i-form style="height:100%;" :model="row">
                    <app-form-item :name="column.property" :itemRules="rules[column.property]">
                        ${P.getEditorCode(item, "GRIDEIDTOR.vue").code}
                    </app-form-item>
                </i-form>
            </template>
              </#if>
            <#--  END：行编辑  -->
            </#if>
            <template <#if (ctrl.isEnableRowEdit() && item.isEnableRowEdit())>v-if="!actualIsOpenEdit"</#if>>
                <#if (item.render??)>
                <#--  BEGIN：列绘制  -->
                    <span>${item.render.code}</span>
                <#--  END：列绘制  -->
                <#elseif (item.getCodeList()?? && item.getCLConvertMode() == 'FRONT')>
                <#--  BEGIN：前端绘制代码表  --> 
                <#assign codelist = item.getPSCodeList()>
                <#if codelist.getCodeListType() == 'STATIC' || codelist.getCodeListType() == 'DYNAMIC'>
                    <#if codelist.getOrMode() == 'STR'>
                    <codelist srfkey="${item.getCodeList().codeName}" :value="row.${item.getName()?lower_case}" emptytext="${codelist.getEmptyText()}" codelistType="${codelist.getCodeListType()}" renderMode="string" textSeparator="${codelist.textSeparator}" valueSeparator="${codelist.valueSeparator}"></codelist>
                    <#elseif codelist.getOrMode() == 'NUM'>
                    <codelist srfkey="${item.getCodeList().codeName}" :value="row.${item.getName()?lower_case}" emptytext="${codelist.getEmptyText()}" codelistType="${codelist.getCodeListType()}" renderMode="number" textSeparator="${codelist.textSeparator}"></codelist>
                    <#else>
                    <codelist srfkey="${item.getCodeList().codeName}" :value="row.${item.getName()?lower_case}" emptytext="${codelist.getEmptyText()}" codelistType="${codelist.getCodeListType()}" renderMode="other"></codelist>
                    </#if>
                </#if>
                <#--  END：前端绘制代码表  -->
                <#else>
                <#--  BEGIN：常规显示  -->
                  <#if item.getPSDEGridEditItem()?? && item.getPSDEGridEditItem().getPSEditorType?? && item.getPSDEGridEditItem().getPSEditorType()??>
                    <app-span editorType="${item.getPSDEGridEditItem().getPSEditorType().getStandardPSEditorType()}" :data="row.${item.getName()?lower_case}"></app-span>
                  <#else>
                    <span>{{row.${item.getName()?lower_case}}}</span>
                  </#if>
                <#--  END：常规显示  -->
                </#if>
            </template>
        <#--  END：列绘制、前端绘制代码表、行编辑  -->
        <#else>
        <#--  BEGIN：常规显示  -->
            <span>{{row.${item.getName()?lower_case}}}</span>
        <#--  END：常规显示  -->
         </#if>
        </template>
    </el-table-column>
<#--  END：数据列  -->
</#if>
</template>

